library usdAffinity;

//uses SysUtils, StrUtils, Windows, classes;
uses SysUtils, StrUtils, Windows;

{$E .plg}

type
  TPlgCallBack=procedure(const AText: PChar); stdcall;
  TSetRetResult=procedure(const AText: PChar); stdcall;
  TSaveToLog = procedure (const AText: PChar); stdcall;
  TShowMsg = function (const AText: PChar; const mode: Byte): Integer; stdcall; //0 - info, 1 - confirmation, 2 - Error
  TGetFuncAddr = function (const AFuncName: PChar): Pointer; stdcall;
  TSimpleOptions = procedure (const OptionScript: PChar; const CallBack: TPlgCallBack); stdcall;
  TGetOption = procedure (const Plugin, Option, DefVal: PChar; const CallBack: TPlgCallBack); stdcall;
  TSetOption = procedure (const Plugin, Option, Value: PChar); stdcall;

var
    SaveToLog: TSaveToLog;
    ShowMsg: TShowMsg;
    SetRetResult: TSetRetResult;
    RezFromMainApp: AnsiString;

    GetFuncAddr: TGetFuncAddr;
  SimpleOptions: TSimpleOptions;
  GetOption: TGetOption;
  SetOption: TSetOption;

  processors: integer;
  plgName: string = 'usdAffinity';
  sotemplate: string;

//  ,    1  
// GET  POST 
procedure PlgCallBack(const AText: PChar); stdcall;
begin
  RezFromMainApp:=StrPas(AText);
end;{}

function SetAffinity(const mask: integer): integer;
var
  hProc: integer;
  r: longbool;

begin
  result := 0;
  hProc := OpenProcess(PROCESS_SET_INFORMATION, false, GetCurrentProcessId());
  if hProc = 0 then begin
     result := GetLastError();
     exit;
  end;
  r := SetProcessAffinityMask(hProc, mask);
  if r = false then result := GetLastError();
  CloseHandle(hProc);
end;

function GetMyOption(o:string; d:string):string;
begin
  GetOption(pchar(plgName), pchar(o), pchar(d), @PlgCallBack);
  result:=LowerCase(RezFromMainApp);
end;

procedure SetMyOption(o:string; v:string);
begin
  SetOption(pchar(plgName), pchar(o), pchar(v));
end;

procedure SetAffinityFromConfig();
var
  opt: AnsiString;
  cpu: integer;
  mask: integer;
  err: integer;

begin
  opt := GetMyOption('Disabled', '1');
  if opt <> '0' then exit;

  opt := GetMyOption('Random', '0');
  if opt <> '0' then opt := IntToStr(Random(processors))
  else opt := GetMyOption('CPU', '0');

  if (cpu >= processors) or (not TryStrToInt(opt, cpu)) then
  begin
    cpu:=0;  //     :-)
    SaveToLog(pchar(plgName + ': invalid option value: '+opt+'; CPU 0 selected.'));
  end;

  SaveToLog(pchar(plgName + ': setting affinity to CPU '+IntToStr(cpu)+'...'));

  mask := 1 shl cpu;
  err := SetAffinity(mask);
  if err = 0 then SaveToLog(pchar(plgName + ': success!'))
  else begin
    SaveToLog(pchar(plgName + ': GetLastError() = '+IntToStr(err)));
  end;

end;


//    .
procedure PlgInit(const funcGet, funcPost, funcSaveToLog, funcGetFuncAddr, funcSaveToFile, funcRetResult: Pointer; const Debug: byte; const AWorkDir: PChar); stdcall;
var
  si: SYSTEM_INFO;
begin
  @SaveToLog:=funcSavetoLog;    //   SaveToLog
  @SetRetResult:=funcRetResult; //   SetRetResult
  @GetFuncAddr:=funcGetFuncAddr;   //     
  @ShowMsg:=GetFuncAddr('ShowMsg');//       ShowMsg
  @SimpleOptions:=GetFuncAddr('SimpleOptions');
  @GetOption:=GetFuncAddr('GetOption');
  @SetOption:=GetFuncAddr('SetOption');

  Randomize();

  GetSystemInfo(si);
  processors:=si.dwNumberOfProcessors;
  SaveToLog(pchar(plgName + ': found '+IntToStr(si.dwNumberOfProcessors)+' processors'));
  if processors > 32 then
  begin
    processors := 32;
    SaveToLog(pchar(plgName + ': bug?'));
  end;

  SetAffinityFromConfig();

  SetRetResult('|1036');


end;

//   
procedure PlgDestroy; stdcall;
begin
end;

procedure PlgGetAbout; stdcall;
begin
  //Plugin Info...
  ShowMsg('usdAffinity 2.1',0);
end;

function GetVal(o:string; v:string):string;
var
  p: integer;
begin
  o:=#10+o+#10;
  p:= pos(#10+v+'=', o) + length(v) +2;
  result:=copy(o, p, PosEx(#10,o,p)-p);
end;

procedure PlgGetOptions; stdcall;
var
  oDis: string;
  oRnd: string;
  oCpu: string;
  //oname, ovalue: string;
  //e: integer;
  I: integer;
  //TS: TStringList;
begin

  oDis := GetMyOption('Disabled', '1');
  oRnd := GetMyOption('Random', '0');
  oCPU := GetMyOption('CPU', '0');

  sotemplate:='type=form|width=242|height=200|caption=usdAffinity'+#13+#10
             +'type=checkbox|left=5|top=5|width=216|height=13|caption=Disable|name=Disabled|value='+oDis+#13+#10
             +'type=checkbox|left=5|top=22|width=216|height=17|caption=Random|name=Random|value='+oRnd+#13+#10
             +'type=select|left=62|top=64|width=121|height=21|name=CPU|value='+oCpu
             //+#13+#10
             ;
  for I:=0 to processors-1 do
    sotemplate := sotemplate + '|item'+IntToStr(I+1)+'=CPU '+IntToStr(I);

  RezFromMainApp:='';
  SimpleOptions(pchar(sotemplate), @PlgCallBack);
  if RezFromMainApp = '' then exit;

  //TS := TStringList.Create;
  //TS.Delimiter := #10;
  //TS.DelimitedText := RezFromMainApp;
//
  //for i:=0 to TS.count-1 do
  //begin
  //  e:=pos('=', TS.strings[i]);
  //  oname := Copy(TS.strings[i], 1, e-1);
  //  ovalue := Copy(TS.strings[i], e+1, Length(TS.strings[i])-e);
  //  SetMyOption(oname, ovalue);
  //end;
  //TS.free; //FreeAndNil(TS);

  //o:=copy(RezFromMainApp, 1, length(RezFromMainApp));
  //SetMyOption('Disabled', GetVal(o, 'Disabled'));
  //SetMyOption('Random', GetVal(o, 'Random'));
  //SetMyOption('CPU', GetVal(o, 'CPU'));

  SetMyOption('Disabled', GetVal(RezFromMainApp, 'Disabled'));
  SetMyOption('Random', GetVal(RezFromMainApp, 'Random'));
  SetMyOption('CPU', GetVal(RezFromMainApp, 'CPU'));

  SetAffinityFromConfig();

end;

exports
  PlgInit,
  PlgGetAbout,
  PlgGetOptions;


begin
end.
